Index: trunk/source/geometry/magneticfield/include/G4MagErrorStepper.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagErrorStepper.icc	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4MagErrorStepper.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagErrorStepper.icc,v 1.13 2006/06/29 18:22:52 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.hh	(revision 1228)
@@ -27,5 +27,5 @@
 //
 // $Id: G4MagHelicalStepper.hh,v 1.15 2007/08/21 08:48:28 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.icc	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagHelicalStepper.icc,v 1.13 2007/05/18 15:45:15 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Linear Step in regions of no field
Index: trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagIntegratorDriver.hh,v 1.20 2007/05/10 10:10:05 japost Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.icc	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagIntegratorDriver.icc,v 1.13 2007/05/10 10:10:48 japost Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.hh	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MagIntegratorStepper.hh,v 1.12 2006/09/20 09:31:01 japost Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4MagIntegratorStepper.hh,v 1.14 2009/11/05 18:31:15 japost Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -75,10 +75,18 @@
        // over the segment last integrated.
 
+     virtual void ComputeRightHandSide( const G4double y[], G4double dydx[] ); 
+       // Must compute the RightHandSide as in the method below
+       // Optionally can cache the input y[] and the dydx[] values computed.
+
      inline void NormaliseTangentVector( G4double vec[6] );
        // Simple utility function to (re)normalise 'unit velocity' vector.
+
+     inline void NormalisePolarizationVector( G4double vec[12] );
+       // Simple utility function to (re)normalise 'unit spin' vector.
 
      inline void RightHandSide( const double y[], double dydx[] );   
        // Utility method to supply the standard Evaluation of the
        // Right Hand side of the associated equation.
+
 
      inline G4int  GetNumberOfVariables() const;
Index: trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.icc	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.icc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MagIntegratorStepper.icc,v 1.10 2006/09/20 09:31:46 japost Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4MagIntegratorStepper.icc,v 1.12 2009/03/25 15:29:02 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
@@ -37,5 +37,6 @@
  G4MagIntegratorStepper::SetEquationOfMotion(G4EquationOfMotion* newEquation)
 {
-  if( newEquation != 0 ) {
+  if( newEquation != 0 )
+  {
     fEquation_Rhs= newEquation;
   }
@@ -55,10 +56,4 @@
 }
 
-// inline
-// void G4MagIntegratorStepper::SetNumberOfVariables(G4int newNo)
-// {
-//   fNumberOfVariables = newNo;
-// }
-
 inline
 void G4MagIntegratorStepper::RightHandSide( const  double y[], double dydx[] )   
@@ -70,10 +65,25 @@
 void G4MagIntegratorStepper::NormaliseTangentVector( G4double vec[6] )
 {
-   double drds2 = vec[3]*vec[3]+vec[4]*vec[4]+vec[5]*vec[5];
+  G4double drds2 = vec[3]*vec[3]+vec[4]*vec[4]+vec[5]*vec[5];
 
-   if( std::fabs(drds2 - 1.0) > 1.e-14 ){
-      double normx = 1.0 / std::sqrt(drds2);
-      for(int i=0;i<3;i++) 
-	 vec[i+3] *= normx;   
-   }
+  if( std::fabs(drds2 - 1.0) > 1.e-14 )
+  {
+    G4double normx = 1.0 / std::sqrt(drds2);
+    for(G4int i=3;i<6;i++) { vec[i] *= normx; }
+  }
 }
+
+inline
+void G4MagIntegratorStepper::NormalisePolarizationVector( G4double vec[12] )
+{
+  G4double drds2 = vec[9]*vec[9]+vec[10]*vec[10]+vec[11]*vec[11];
+
+  if( drds2 > 0. )
+  {
+    if( std::fabs(drds2 - 1.0) > 1.e-14 )
+    {
+      G4double normx = 1.0 / std::sqrt(drds2);
+      for(G4int i=9;i<12;i++)  { vec[i] *= normx; }
+    }
+  }
+}
Index: trunk/source/geometry/magneticfield/include/G4Mag_EqRhs.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4Mag_EqRhs.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4Mag_EqRhs.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Mag_EqRhs.hh,v 1.9 2006/06/29 18:23:07 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4Mag_SpinEqRhs.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4Mag_SpinEqRhs.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4Mag_SpinEqRhs.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Mag_SpinEqRhs.hh,v 1.11 2006/06/29 18:23:09 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4Mag_UsualEqRhs.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4Mag_UsualEqRhs.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4Mag_UsualEqRhs.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Mag_UsualEqRhs.hh,v 1.7 2006/06/29 18:23:12 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagneticField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagneticField.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4MagneticField.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagneticField.hh,v 1.14 2006/06/29 18:23:14 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4QuadrupoleMagField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4QuadrupoleMagField.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4QuadrupoleMagField.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4QuadrupoleMagField.hh,v 1.4 2006/06/29 18:23:16 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4RKG3_Stepper.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4RKG3_Stepper.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4RKG3_Stepper.hh	(revision 1228)
@@ -27,5 +27,5 @@
 //
 // $Id: G4RKG3_Stepper.hh,v 1.13 2007/05/18 12:44:02 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4SimpleHeum.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4SimpleHeum.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4SimpleHeum.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SimpleHeum.hh,v 1.8 2006/06/29 18:23:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4SimpleRunge.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4SimpleRunge.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4SimpleRunge.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SimpleRunge.hh,v 1.8 2006/06/29 18:23:23 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4UniformElectricField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4UniformElectricField.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4UniformElectricField.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4UniformElectricField.hh,v 1.9 2006/06/29 18:23:25 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/magneticfield/include/G4UniformMagField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4UniformMagField.hh	(revision 1227)
+++ trunk/source/geometry/magneticfield/include/G4UniformMagField.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4UniformMagField.hh,v 1.9 2006/06/29 18:23:27 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/management/History
===================================================================
--- trunk/source/geometry/management/History	(revision 1227)
+++ trunk/source/geometry/management/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.131 2008/09/23 13:10:55 gcosmo Exp $
+$Id: History,v 1.138 2009/11/27 16:34:53 gcosmo Exp $
 -------------------------------------------------------------------
 
@@ -17,4 +17,29 @@
      * Reverse chronological order (last date on top), please *
      ----------------------------------------------------------
+
+November 27, 2009  G.Cosmo                 geommng-V09-02-05
+- G4Region: added pointer to field-manager and associated accessor/modifier.
+
+November 6, 2009  G.Cosmo                  geommng-V09-02-04
+- G4VTouchable: moved inline vitual methods, constructor and destructor to
+  source, to avoid problem of memory alignment in allocation of derived objects.
+
+October 30, 2009  G.Cosmo                  geommng-V09-02-03
+- Clear possible excess capacity in node vectors in G4SmartVoxelHeader
+  BuildNodes() method. May reduce excess memory allocated in optimisation
+  in large detector setups, with slight time increase in initialisation for
+  geometry voxelisation.
+
+September 24, 2009  G.Cosmo                geommng-V09-02-02
+- Fixed implementation of G4LogicalVolume::TotalVolumeEntities() to become
+  invariant to call sequence.
+
+May 25, 2009  G.Cosmo                      geommng-V09-02-01
+- Fixed initialisation of min/max extent in method BuildReplicaVoxels() in
+  G4SmartVoxelHeader.
+
+April 16, 2009  G.Cosmo                    geommng-V09-02-00
+- Adopt 'const' references for strings as arguments/return-values in
+  G4LogicalSurface. Some minor cleanup...
 
 September 23, 2008  G. Cosmo               geommng-V09-01-08
Index: trunk/source/geometry/management/include/G4AffineTransform.hh
===================================================================
--- trunk/source/geometry/management/include/G4AffineTransform.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4AffineTransform.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4AffineTransform.hh,v 1.6 2006/06/29 18:30:37 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4AffineTransform.icc
===================================================================
--- trunk/source/geometry/management/include/G4AffineTransform.icc	(revision 1227)
+++ trunk/source/geometry/management/include/G4AffineTransform.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4AffineTransform.icc,v 1.8 2006/06/29 18:30:39 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4BlockingList.hh
===================================================================
--- trunk/source/geometry/management/include/G4BlockingList.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4BlockingList.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4BlockingList.hh,v 1.4 2006/06/29 18:30:41 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4BlockingList
Index: trunk/source/geometry/management/include/G4BlockingList.icc
===================================================================
--- trunk/source/geometry/management/include/G4BlockingList.icc	(revision 1227)
+++ trunk/source/geometry/management/include/G4BlockingList.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4BlockingList.icc,v 1.3 2006/06/29 18:30:43 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4ErrorCylSurfaceTarget.hh
===================================================================
--- trunk/source/geometry/management/include/G4ErrorCylSurfaceTarget.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4ErrorCylSurfaceTarget.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ErrorCylSurfaceTarget.hh,v 1.1 2007/05/16 12:50:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4ErrorPlaneSurfaceTarget.hh
===================================================================
--- trunk/source/geometry/management/include/G4ErrorPlaneSurfaceTarget.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4ErrorPlaneSurfaceTarget.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ErrorPlaneSurfaceTarget.hh,v 1.1 2007/05/16 12:50:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4ErrorSurfaceTarget.hh
===================================================================
--- trunk/source/geometry/management/include/G4ErrorSurfaceTarget.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4ErrorSurfaceTarget.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ErrorSurfaceTarget.hh,v 1.1 2007/05/16 12:50:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4ErrorTanPlaneTarget.hh
===================================================================
--- trunk/source/geometry/management/include/G4ErrorTanPlaneTarget.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4ErrorTanPlaneTarget.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ErrorTanPlaneTarget.hh,v 1.1 2007/05/16 12:50:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4ErrorTarget.hh
===================================================================
--- trunk/source/geometry/management/include/G4ErrorTarget.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4ErrorTarget.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ErrorTarget.hh,v 1.1 2007/05/16 12:50:52 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4GeometryManager.hh
===================================================================
--- trunk/source/geometry/management/include/G4GeometryManager.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4GeometryManager.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GeometryManager.hh,v 1.12 2007/05/11 13:30:12 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GeometryManager
Index: trunk/source/geometry/management/include/G4IdentityTrajectoryFilter.hh
===================================================================
--- trunk/source/geometry/management/include/G4IdentityTrajectoryFilter.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4IdentityTrajectoryFilter.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4IdentityTrajectoryFilter.hh,v 1.3 2006/06/29 18:30:48 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4LogicalSurface.hh
===================================================================
--- trunk/source/geometry/management/include/G4LogicalSurface.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4LogicalSurface.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4LogicalSurface.hh,v 1.10 2006/06/29 18:30:50 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4LogicalSurface.hh,v 1.11 2009/04/21 15:18:15 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 ////////////////////////////////////////////////////////////////////////
@@ -86,25 +86,23 @@
    void     SetSurfaceProperty(G4SurfaceProperty* ptrSurfaceProperty);
 
-   G4String GetName() const;
+   const G4String& GetName() const;
    void     SetName(const G4String& name);
 
    G4TransitionRadiationSurface*  GetTransitionRadiationSurface() const;
-   void SetTransitionRadiationSurface(G4TransitionRadiationSurface* transRadSurf);
+   void SetTransitionRadiationSurface(G4TransitionRadiationSurface* tRadSurf);
+
+ public:  // without description
+
+   virtual ~G4LogicalSurface();
+
+   G4int operator==(const G4LogicalSurface &right) const;
+   G4int operator!=(const G4LogicalSurface &right) const;
 
  protected:
 
-        // There should be no instances of this class
+   // There should be no instances of this class
 
-   G4LogicalSurface(const G4String&         name,
-                    G4SurfaceProperty* surfaceProperty); 
-        // Is the name more meaningful for the properties or the logical
-        // surface ?  
-
- public:
-   virtual ~G4LogicalSurface();
-
- public:
-   G4int operator==(const G4LogicalSurface &right) const;
-   G4int operator!=(const G4LogicalSurface &right) const;
+   G4LogicalSurface(const G4String& name, G4SurfaceProperty* surfaceProperty); 
+     // Is the name more meaningful for the properties or the logical surface ?
 
  private:
@@ -117,5 +115,5 @@
    G4String theName;              // Surface name
 
-   G4SurfaceProperty*              theSurfaceProperty;
+   G4SurfaceProperty*             theSurfaceProperty;
    G4TransitionRadiationSurface*  theTransRadSurface;
 };
Index: trunk/source/geometry/management/include/G4LogicalSurface.icc
===================================================================
--- trunk/source/geometry/management/include/G4LogicalSurface.icc	(revision 1227)
+++ trunk/source/geometry/management/include/G4LogicalSurface.icc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4LogicalSurface.icc,v 1.9 2006/06/29 18:30:52 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4LogicalSurface.icc,v 1.10 2009/04/21 15:18:15 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 ////////////////////////////////////////////////////////////////////////
@@ -51,5 +51,5 @@
 } 
 
-inline G4String
+inline const G4String&
 G4LogicalSurface::GetName() const
 {
@@ -110,6 +110,5 @@
 inline G4LogicalSurface::G4LogicalSurface(const G4String&         name,
                                          G4SurfaceProperty* surfaceProperty) 
-                : theName(name),
-                  theSurfaceProperty(surfaceProperty)
+  : theName(name), theSurfaceProperty(surfaceProperty)
 {
 }
Index: trunk/source/geometry/management/include/G4LogicalVolume.hh
===================================================================
--- trunk/source/geometry/management/include/G4LogicalVolume.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4LogicalVolume.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalVolume.hh,v 1.27 2008/07/10 09:40:08 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/management/include/G4LogicalVolume.icc
===================================================================
--- trunk/source/geometry/management/include/G4LogicalVolume.icc	(revision 1227)
+++ trunk/source/geometry/management/include/G4LogicalVolume.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalVolume.icc,v 1.25 2008/07/10 09:40:08 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/management/include/G4LogicalVolumeStore.hh
===================================================================
--- trunk/source/geometry/management/include/G4LogicalVolumeStore.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4LogicalVolumeStore.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogicalVolumeStore.hh,v 1.13 2007/04/10 10:13:50 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4LogicalVolumeStore
Index: trunk/source/geometry/management/include/G4PhysicalVolumeStore.hh
===================================================================
--- trunk/source/geometry/management/include/G4PhysicalVolumeStore.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4PhysicalVolumeStore.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PhysicalVolumeStore.hh,v 1.16 2008/07/10 09:41:20 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4PhysicalVolume
Index: trunk/source/geometry/management/include/G4ReflectedSolid.hh
===================================================================
--- trunk/source/geometry/management/include/G4ReflectedSolid.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4ReflectedSolid.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ReflectedSolid.hh,v 1.5 2006/06/29 18:31:03 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4Region.hh
===================================================================
--- trunk/source/geometry/management/include/G4Region.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4Region.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Region.hh,v 1.20 2008/07/10 09:46:01 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Region.hh,v 1.21 2009/11/27 16:34:37 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4Region
@@ -48,4 +48,5 @@
 class G4MaterialCutsCouple;
 class G4UserLimits;
+class G4FieldManager;
 class G4FastSimulationManager;
 class G4VPhysicalVolume;
@@ -144,4 +145,11 @@
       // if it exists. Otherwise set to null.
 
+    inline void SetFieldManager(G4FieldManager* fm);
+    inline G4FieldManager* GetFieldManager() const;
+      // Set and Get methods for G4FieldManager.
+      // The region with assigned field-manager sets the field to the
+      // geometrical area associated with it; priority is anyhow given
+      // to local fields eventually set to logical volumes.
+
     inline G4VPhysicalVolume* GetWorldPhysical() const;
       // Get method for the world physical volume which this region
@@ -199,4 +207,5 @@
     G4VUserRegionInformation* fUserInfo;
     G4UserLimits* fUserLimits;
+    G4FieldManager* fFieldManager;
 
     G4FastSimulationManager* fFastSimulationManager;
Index: trunk/source/geometry/management/include/G4Region.icc
===================================================================
--- trunk/source/geometry/management/include/G4Region.icc	(revision 1227)
+++ trunk/source/geometry/management/include/G4Region.icc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Region.icc,v 1.15 2007/04/28 01:48:29 asaim Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Region.icc,v 1.16 2009/11/27 16:34:37 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -247,4 +247,24 @@
 {
   return fFastSimulationManager;
+}
+
+// ********************************************************************
+// GetFieldManager
+// ********************************************************************
+//
+inline 
+G4FieldManager* G4Region::GetFieldManager() const
+{
+  return fFieldManager;
+}
+
+// ********************************************************************
+// SetFieldManager
+// ********************************************************************
+//
+inline
+void G4Region::SetFieldManager(G4FieldManager* fm)
+{
+  fFieldManager = fm;
 }
 
Index: trunk/source/geometry/management/include/G4RegionStore.hh
===================================================================
--- trunk/source/geometry/management/include/G4RegionStore.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4RegionStore.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4RegionStore.hh,v 1.10 2006/11/30 10:39:28 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4RegionStore
Index: trunk/source/geometry/management/include/G4SmartVoxelHeader.hh
===================================================================
--- trunk/source/geometry/management/include/G4SmartVoxelHeader.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4SmartVoxelHeader.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SmartVoxelHeader.hh,v 1.10 2006/06/29 18:32:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4SmartVoxelHeader
Index: trunk/source/geometry/management/include/G4SmartVoxelHeader.icc
===================================================================
--- trunk/source/geometry/management/include/G4SmartVoxelHeader.icc	(revision 1227)
+++ trunk/source/geometry/management/include/G4SmartVoxelHeader.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SmartVoxelHeader.icc,v 1.6 2006/06/29 18:32:09 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4SmartVoxelNode.hh
===================================================================
--- trunk/source/geometry/management/include/G4SmartVoxelNode.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4SmartVoxelNode.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SmartVoxelNode.hh,v 1.12 2008/01/24 15:47:23 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4SmartVoxelNode
Index: trunk/source/geometry/management/include/G4SmartVoxelNode.icc
===================================================================
--- trunk/source/geometry/management/include/G4SmartVoxelNode.icc	(revision 1227)
+++ trunk/source/geometry/management/include/G4SmartVoxelNode.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SmartVoxelNode.icc,v 1.7 2008/01/24 15:47:23 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4SmartVoxelProxy.hh
===================================================================
--- trunk/source/geometry/management/include/G4SmartVoxelProxy.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4SmartVoxelProxy.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SmartVoxelProxy.hh,v 1.8 2006/06/29 18:32:17 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4SmartVoxelProxy
Index: trunk/source/geometry/management/include/G4SmartVoxelProxy.icc
===================================================================
--- trunk/source/geometry/management/include/G4SmartVoxelProxy.icc	(revision 1227)
+++ trunk/source/geometry/management/include/G4SmartVoxelProxy.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SmartVoxelProxy.icc,v 1.4 2006/06/29 18:32:19 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/geometry/management/include/G4SmartVoxelStat.hh
===================================================================
--- trunk/source/geometry/management/include/G4SmartVoxelStat.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4SmartVoxelStat.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4SmartVoxelStat.hh,v 1.4 2006/06/29 18:32:21 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/management/include/G4SolidStore.hh
===================================================================
--- trunk/source/geometry/management/include/G4SolidStore.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4SolidStore.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SolidStore.hh,v 1.13 2007/04/10 10:13:50 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4SolidStore
Index: trunk/source/geometry/management/include/G4TouchableHandle.hh
===================================================================
--- trunk/source/geometry/management/include/G4TouchableHandle.hh	(revision 1227)
+++ trunk/source/geometry/management/include/G4TouchableHandle.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TouchableHandle.hh,v 1.6 2006/06/29 18:32:25 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Class G4TouchableHandle
